// C Source File
// Created 12/17/00; 6:52:29 PM

// Available Patches
// #define USE_LONGMUL_PATCH
// #define USE_LONGDIV_PATCH
// #define USE_INITS_PATCH

// By MurBeck 2000
// Written by: Stephen Schloterbeck
// Open source so long as MurBeck is given credit
// E-Mail Me at: www.Augurean@aol.com   -or-
//     Rian at: www.Dracko22@aol.com
//********************************************************

#define OPTIMIZE_ROM_CALLS    // Use Speed Optimization

#define RETURN_VALUE sysvar

#include <tigcclib.h>         // Include All Header Files

int _ti89;                    // Produce .89Z File
int _ti92plus;                // Produce .9XZ File

// Main Function
char _comment[] = "System Utilities V2.5";  //Comment for an explorer  (i.e. Doors)

void _main(void)
{
  //Place your code here
	ESI argptr;   //Variables and arguements
	char* str;
	char TIOSname[50];
	int func = 1;
	int inpt = 1;
	unsigned int size;
	int a = 1;
	int b = 1;
	int c = 1;
	int argtype,argtype2;
	a = ArgCount(); //See how many arguments user gave us
	InitArgPtr (argptr);
	argtype = GetArgType (argptr);
	func = GetIntArg (argptr);
	if (a == 2) argtype2 = GetArgType(argptr); //Only gets second argument if one exists
	if (a == 2) if (argtype2 != STR_TAG) inpt = GetIntArg (argptr);
	
	if (argtype == STR_TAG) 
	{
	InitArgPtr (argptr);
	ST_helpMsg(GetStrnArg (argptr));  //Display message on status line
	goto End;
	}
	if (func == 1) OSContrastUp ();  //Raises contrast one level
	if (func == 2) OSContrastDn ();  //Decreses contrast one level
	if (func == 3)  //returns the current setting for the Automatic Power-Down (APD)
	{
	  OSTimerRestart (APD_TIMER);
	  a = OSTimerCurVal (APD_TIMER);
	  push_longint(a/20);
	}
	if (func == 4)  //Store user input as APD timer---sysutil(4,250)
	{
	 OSFreeTimer (APD_TIMER);
	 OSRegisterTimer (APD_TIMER,inpt*20);
	}
	if (func != 5) goto End1; //Scrambles screen contents(slow) to hide what is there 
	 ClrScr();  //Use func#7 to restore status line
	 b = 0;
Scm1:
   b = b+1;
	 a = 0;
Scrmbl:
   a = a+1;
   c = random(2);
   if (c == 0) DrawPix(a,b,A_NORMAL);
   if (a == 240)
   {
     if (b == 128) goto End1;
     goto Scm1;
   }
   goto Scrmbl;
End1:
	if (func == 6) OSReset();  //Resets your calculator
	if (func == 7) //Resets the status line and cursor in the event they were tampered with
	{
	DrawLine (0,121,240,121,A_NORMAL);
	CU_start();
	CU_restore(1);
	ST_helpMsg ("");
	ST_eraseHelp ();
	}
	if (func == 8) off ();  //Turns calc off
	if (func == 9) //Sets calc in an idle loop waiting for a key press
	{
	idle();
	ngetchx();
	}
	if (func == 10)  //Locks up calc. Might be needed to protect calc?
	{
LockUp:
    goto LockUp;
	}
	if (func == 11)	FontSetSys (F_4x6);  //Sets font to small(4x6)  --to use first use DispG command, then
	if (func == 12) FontSetSys (F_6x8);  //Sets font to normal(6x8) -call sysutil(11-13), then use pxltext
	if (func == 13) FontSetSys (F_8x10); //Sets font to large(8x10) -command. spacing will be off some...
	if (func == 14) ClrScr();  //Clears the entire screen, use func#7 to get back the status line
  if (func == 15) //Performs a Garbage Collection of the archive to free up memory
  {
  	EM_GC (TRUE);
  }
  if (func == 16) //Puts a string into the system clipboard --- sysutil(16,"Hello yo!")
  {
  	if (argtype2 == STR_TAG)
  	{
  		str = GetStrnArg (argptr);
  		CB_replaceTEXT (str,strlen(str),TRUE);
  	}
  }
  if (func == 17) //Restarts the calculator timer using arg#2 as the new time
  {
   OSFreeTimer (USER_TIMER);
   OSRegisterTimer (USER_TIMER, inpt*20);
  }
  if (func == 18) //Gets the current time of the timer
  {
   a = OSTimerCurVal (USER_TIMER);
   push_longint (a/20);
  }
  if (func == 19) 
  {
  OSClearBreak (); //This clears the break key [ON] in case it was already set
  OSDisableBreak (); // Disables the break key [ON] so that the user can't quit the program
  }
  if (func == 20) OSEnableBreak (); //Enables break key [ON] so that it can be used to exit prgm, remember to use this after disabling it so other programs can be quit from without resetting
  if (func == 22) MO_modeDialog (); //Opens up the "Mode" dialog box and lets the user change its contents
  if (func == 23) HelpKeys (); //Opens the box that displays the special keys on the keyboard
  if (func == 24) ScrRectFill (&(SCR_RECT){{0,0,239,127}},ScrRect,A_NORMAL); //turns the whole screen
  if (func == 25) ScrRectFill (&(SCR_RECT){{0,0,239,127}},ScrRect,A_XOR);
  if (func == 26) //returns the list of folders or the list of files in the specified folder
  {
    int FindType;
	  SYM_ENTRY *SymPtr;
	
	  if (GetArgType(argptr) == END_TAG)
	  	FindType = 0;
	  else
	  	FindType = 1;
		
	  SymPtr = SymFindFirst (GetSymstrArg (argptr), FindType);
	  push_END_TAG();
	  while (SymPtr)
	  {
		  push_ANSI_string (SymPtr->name);
		  SymPtr = SymFindNext();
	  }
	  push_LIST_TAG();
  }
  if (func == 27)
  {
   SYM_ENTRY *sym;
   TIOSname[0] = 0;
   str = GetStrnArg(argptr);
   sym=SymFindPtr(strcpy (TIOSname + 1, str) + strlen (str), 0);
   size = *(unsigned int*) HeapDeref (sym->handle) + 2;
   a = size;
   push_longint (a);
  }
  if (func > 27) ST_helpMsg ("Bad Input (1-27)"); //Tells the user that they entered a wrong arguement
End:
  return;
}
